<?php


//-------------------------------------------------------------------
// テンプレート
//-------------------------------------------------------------------

$_HTML = array();

class html {

	// 置き換え要素
	public $values = array();

	// テーマファイル格納用
	public $theme_files = array();

	// テーマファイルの登録
	public function regist_theme_file($name,$path,$url) {
		$this->theme_files[$name] = array(
			'path' => $path,
			'url'  => $url,
		);
	}

	// テンプレートファイルパスを戻す
	public function get_theme_file_path($name) {
		return $this->theme_files[$name]['path'];
	}

	// テンプレートファイルURLを戻す
	public function get_theme_file_url($name) {
		return $this->theme_files[$name]['url'];
	}

	// 置き換え要素の登録
	public function set_value($var,$val) {
		$this->values[$var] = $val;
	}

	// 置き換え要素の登録
	public function set_value_array($ary) {
		$this->values = array_merge($this->values,$ary);
	}

	// テンプレートの適用
	public function apply($tmpl) {

		$tmpl = $this->get_theme_file_path($tmpl);

		if (file_exists($tmpl)) {
			$html = file_get_contents($tmpl);
		} else {
			$html = '{{doc}}';
		}

		$html = $this->_apply_include($html);
		$html = $this->_apply_replace($html);

		return $html;
	}

	// インクルード処理
	private function _apply_include($html) {

		$html = preg_replace_callback(
			'/{{include:(.+?)}}/',
			array($this,'_apply_include_callback'),
			$html
		);

		return $html;

	}

	// インクルード処理(コールバック関数)
	private function _apply_include_callback($matches) {

		$path = $this->get_theme_file_path($matches[1]);
		if (file_exists($path)) {
			return file_get_contents($path);
		} else {
			return '';
		}

	}

	// 置き換え処理
	private function _apply_replace($html) {

		$html = preg_replace_callback(
			'/{{(.+?)}}/',
			array($this,'_apply_replace_callback'),
			$html
		);

		return $html;

	}

	// 置き換え処理(コールバック関数)
	private function _apply_replace_callback($matches) {

		if (array_key_exists($matches[1],$this->values)) {
			return $this->values[$matches[1]];
		} else {
			return '';
		}

	}

}

?>